> For AI agents: [llms.txt](https://docs.trustedauth.com/llms.txt) provides a Markdown index of this documentation.

# Get a user by userid or user alias

`POST /api/web/v3/users/userid`

Get the specified user by userid or user alias.

## Request Body

Required.

### application/json

Schema

```json
{
  "required": [
    "userId"
  ],
  "type": "object",
  "properties": {
    "userId": {
      "type": "string",
      "description": "If fetching a user by userId or alias, this value specifies, the userId or user alias of the user to be fetched. If fetching a user by externalId, this value specifies, the externalId of the user to be fetched.",
      "example": "John"
    }
  },
  "description": "The user Id or user alias of the user to be fetched.",
  "title": "UserGetParms"
}
```

## Responses

### 200

Successful

#### application/json

Schema

```json
{
  "type": "object",
  "properties": {
    "alternateEmails": {
      "type": "array",
      "description": "A list of all the users alternate emails.",
      "items": {
        "type": "object",
        "properties": {
          "name": {
            "type": "string",
            "description": "Name of the email attribute.",
            "example": "Secondary email"
          },
          "value": {
            "type": "string",
            "description": "Value of the email attribute.",
            "example": "secondary@mycompany.com"
          }
        },
        "description": "Specifies alternate emails for a particular user.",
        "title": "UserAlternateEmails"
      }
    },
    "authenticatorLockoutStatus": {
      "type": "array",
      "description": "A list of all authenticators that the user has with their lockout status.",
      "items": {
        "type": "object",
        "properties": {
          "locked": {
            "type": "boolean",
            "description": "Determines if this authenticator is currently locked out."
          },
          "lockoutDate": {
            "type": "string",
            "description": "The date the user was locked. Null means the user is not locked.",
            "format": "date-time",
            "example": "2019-02-19T13:15:27Z"
          },
          "lockoutExpiryDate": {
            "type": "string",
            "description": "if remainingAuthenticationAttempts is 0 then a lockoutExpiryDate of null means the lockout never expires. Otherwise a value of null means the user isn't locked out.",
            "format": "date-time",
            "example": "2019-02-20T13:15:27Z"
          },
          "name": {
            "type": "string",
            "description": "The users named password authentication that is locked out."
          },
          "remainingAuthenticationAttempts": {
            "type": "integer",
            "description": "The number of authentication attempts remaining before the user is locked out.",
            "format": "int32"
          },
          "type": {
            "type": "string",
            "description": "The type of the authenticator.",
            "example": "OTP",
            "enum": [
              "MACHINE",
              "PASSWORD",
              "EXTERNAL",
              "KBA",
              "TEMP_ACCESS_CODE",
              "OTP",
              "GRID",
              "TOKEN",
              "TOKENCR",
              "TOKENPUSH",
              "FIDO",
              "SMARTCREDENTIALPUSH",
              "PASSWORD_AND_SECONDFACTOR",
              "SMART_LOGIN",
              "IDP",
              "PASSKEY",
              "IDP_AND_SECONDFACTOR",
              "USER_CERTIFICATE",
              "FACE",
              "PASSTHROUGH",
              "MAGICLINK"
            ]
          }
        },
        "description": "Detailed lockout information for each authenticator for a particular user.",
        "title": "UserAuthenticatorLockoutStatus"
      }
    },
    "directoryDN": {
      "type": "string",
      "description": "The DN of the user in the directory the user was synchronized from."
    },
    "directoryId": {
      "type": "string",
      "description": "If the user was synchronized from a directory, the UUID of that directory."
    },
    "directoryName": {
      "type": "string",
      "description": "If the user was synchronized from a directory, the name of that directory."
    },
    "directoryObjectGUID": {
      "type": "string",
      "description": "The objectGUID of the user in the directory the user was synchronized from."
    },
    "directoryType": {
      "type": "string",
      "description": "The type of the directory user was synchronized from.",
      "enum": [
        "ON_PREM",
        "AZURE",
        "AD_CONNECTOR"
      ]
    },
    "email": {
      "type": "string",
      "description": "The email address of this user.  This value may or may not be required depending on configuration. It must be set to use EMAIL OTP authentication and other features that require an email address."
    },
    "externalId": {
      "type": "string",
      "description": "An optional external ID for this user.  This value can be used to track the external identity of an Identity as a Service user. ",
      "example": "John"
    },
    "externalSource": {
      "type": "string",
      "description": "An optional value that describes the source when the user is synchronized from an external source."
    },
    "fidoTokens": {
      "type": "array",
      "description": "A list of all the FIDO tokens owned by this user.",
      "items": {
        "type": "object",
        "properties": {
          "aaguid": {
            "type": "string",
            "description": "The AAGUID of the authenticator that created this FIDO token."
          },
          "aaguidVerified": {
            "type": "boolean",
            "description": "Indicates whether the AAGUID reported by the authenticator was cryptographically verified via a full certificate chain against the FIDO MDS trust anchors. True only for DIRECT attestation; false for INDIRECT (cert chain not verified); null for NONE (no attestation collected)."
          },
          "algorithm": {
            "type": "string",
            "description": "The signature algorithm of the authenticator that created this FIDO token."
          },
          "allowedActions": {
            "type": "array",
            "description": "Administration actions that can be performed on this FIDO token.",
            "items": {
              "type": "string",
              "description": "Administration actions that can be performed on this FIDO token.",
              "enum": [
                "DELETE",
                "ENABLE",
                "DISABLE",
                "RENAME"
              ]
            }
          },
          "attestationFormat": {
            "type": "string",
            "description": "Attestation format of the authenticator that created this FIDO token."
          },
          "attestedData": {
            "type": "boolean",
            "description": "Indicates if this FIDO token contains attested data."
          },
          "authenticatorModel": {
            "type": "string",
            "description": "The authenticator model of the authenticator that created this FIDO token."
          },
          "backupEligible": {
            "type": "boolean",
            "description": "Indicates if this FIDO token is eligible for backup."
          },
          "backupStatus": {
            "type": "boolean",
            "description": "Indicates if this FIDO token is currently backed up."
          },
          "createDate": {
            "type": "string",
            "description": "The date on which the FIDO token was created.",
            "format": "date-time",
            "example": "2019-02-19T13:15:27Z"
          },
          "icon": {
            "type": "string",
            "description": "The icon of the authenticator that created this FIDO token."
          },
          "id": {
            "type": "string",
            "description": "The unique UUID assigned to the fido token when it is registered."
          },
          "lastUsedDate": {
            "type": "string",
            "description": "The date on which this FIDO token was last used for authentication. This value will be null if the FIDO token has never been used.",
            "format": "date-time",
            "example": "2019-02-21T11:37:27Z"
          },
          "name": {
            "type": "string",
            "description": "The name of this FIDO token."
          },
          "origin": {
            "type": "string",
            "description": "The origin of where the FIDO token was generated."
          },
          "relyingPartyId": {
            "type": "string",
            "description": "The relying party ID of where the FIDO token was generated."
          },
          "state": {
            "type": "string",
            "description": "The state of this FIDO token.  Only FIDO tokens in the ACTIVE state can be used for authentication.",
            "enum": [
              "ACTIVE",
              "INACTIVE"
            ]
          },
          "userId": {
            "type": "string",
            "description": "The user Id of the user who owns this FIDO token."
          },
          "userIdStored": {
            "type": "boolean",
            "description": "Indicates if the userId was stored on the FIDO token."
          },
          "userPresent": {
            "type": "boolean",
            "description": "Indicates if the user was present during the registration or authentication ceremony that created or last used this FIDO token."
          },
          "userUUID": {
            "type": "string",
            "description": "The UUID of the user who owns this FIDO token."
          },
          "userVerified": {
            "type": "boolean",
            "description": "Indicates if the user was verified during the registration or authentication ceremony that created or last used this FIDO token."
          }
        },
        "description": "A FIDOToken defines the information returned about a FIDO Token.",
        "title": "FIDOToken"
      }
    },
    "firstName": {
      "type": "string",
      "description": "The first name of this user.  This value may or may not be required depending on configuration."
    },
    "frozen": {
      "type": "boolean",
      "description": "Indicates whether a user is unable to authenticate due to inactivity.",
      "example": true
    },
    "frozenGracePeriod": {
      "type": "string",
      "description": "Indicates a user's frozen grace period.",
      "format": "date-time",
      "example": "2019-02-19T13:15:27Z"
    },
    "grids": {
      "type": "array",
      "description": "A list of all the grids owned by this user.",
      "items": {
        "type": "object",
        "properties": {
          "allowedActions": {
            "type": "array",
            "description": "A list of what actions are currently allowed for this grid.",
            "items": {
              "type": "string",
              "description": "A list of what actions are currently allowed for this grid.",
              "enum": [
                "CANCEL",
                "DELETE",
                "ENABLE",
                "DISABLE",
                "ASSIGN",
                "UNASSIGN"
              ]
            }
          },
          "assignDate": {
            "type": "string",
            "description": "For unassigned grids which were assigned to the user, the date on which the grid was assigned.",
            "format": "date-time",
            "example": "2019-02-19T13:17:27Z"
          },
          "createDate": {
            "type": "string",
            "description": "The date on which the grid was created.",
            "format": "date-time",
            "example": "2019-02-19T13:15:27Z"
          },
          "expired": {
            "type": "boolean",
            "description": "A flag indicating if this grid is currently expired."
          },
          "expiryDate": {
            "type": "string",
            "description": "If the grid policy defines an expiry date, the date on which this grid will expire. Expired grids cannot be used for authentication.",
            "format": "date-time",
            "example": "2019-08-19T13:15:27Z"
          },
          "gridContents": {
            "type": "array",
            "description": "The grid contents of this grid.  Only administrators with the GRIDCONTENTS:VIEW permission will receive this value.",
            "items": {
              "type": "array",
              "description": "The grid contents of this grid.  Only administrators with the GRIDCONTENTS:VIEW permission will receive this value.",
              "items": {
                "type": "string",
                "description": "The grid contents of this grid.  Only administrators with the GRIDCONTENTS:VIEW permission will receive this value."
              }
            }
          },
          "groups": {
            "type": "array",
            "description": "The UUIDs of groups to which this grid belongs.  This value is only used for unassigned grids. Only groups to which the current administrator has access will be returned.",
            "items": {
              "type": "string",
              "description": "The UUIDs of groups to which this grid belongs.  This value is only used for unassigned grids. Only groups to which the current administrator has access will be returned."
            }
          },
          "id": {
            "type": "string",
            "description": "The unique UUID assigned to the grid when it is created."
          },
          "lastUsedDate": {
            "type": "string",
            "description": "The date on which this grid was last used for authentication. This value will be null if the grid has never been used.",
            "format": "date-time",
            "example": "2019-02-19T13:15:27Z"
          },
          "serialNumber": {
            "type": "integer",
            "description": "The unique numeric serial number assigned to the grid when it is created.",
            "format": "int64"
          },
          "state": {
            "type": "string",
            "description": "The state of this grid.  Only grids in the ACTIVE or PENDING state can be used for authentication.",
            "enum": [
              "ACTIVE",
              "INACTIVE",
              "UNASSIGNED",
              "PENDING",
              "CANCELED"
            ]
          },
          "userId": {
            "type": "string",
            "description": "The UUID of the user who owns this grid.  If the grid is not assigned, this value will be null.",
            "example": "45f5a855-962a-4b5f-b5c5-7ceeae235875"
          },
          "userName": {
            "type": "string",
            "description": "The user Id for this user.  If the grid is not assigned, this value will be null.",
            "example": "john.doe"
          }
        },
        "description": "A Grid defines the information returned about a Grid.",
        "title": "Grid"
      }
    },
    "groups": {
      "type": "array",
      "description": "A list of all groups to which this user belongs.",
      "items": {
        "required": [
          "name"
        ],
        "type": "object",
        "properties": {
          "attribute": {
            "type": "string",
            "description": "The attribute of this group."
          },
          "created": {
            "type": "string",
            "description": "When the group was created.",
            "format": "date-time",
            "example": "2019-02-19T13:15:27Z"
          },
          "directoryDesynced": {
            "type": "boolean",
            "description": "Whether the directory group is desynced. Desynced groups can be deleted.",
            "example": false
          },
          "externalId": {
            "type": "string",
            "description": "The externalId of this group."
          },
          "id": {
            "type": "string",
            "description": "The UUID of this group.  This value is generated when the group is created."
          },
          "lastModified": {
            "type": "string",
            "description": "When the group was last modified.",
            "format": "date-time",
            "example": "2019-02-19T13:15:27Z"
          },
          "name": {
            "type": "string",
            "description": "The name of this group."
          },
          "type": {
            "type": "string",
            "description": "The type of group indicating if this group was synchronized from a directory (LDAP_AD) or was created in Identity as a Service (MGMT_UI).",
            "example": "MGMT_UI",
            "enum": [
              "LDAP_AD",
              "MGMT_UI"
            ]
          }
        },
        "description": "Information returned about a group.",
        "title": "Group"
      }
    },
    "id": {
      "type": "string",
      "description": "The unique UUID for this user.  This value is generated by the service when a user is created."
    },
    "lastAuthTime": {
      "type": "string",
      "description": "The last time this user successfully authenticated.  Null if the user has never authenticated.",
      "format": "date-time",
      "example": "2019-02-19T13:15:27Z"
    },
    "lastModified": {
      "type": "string",
      "description": "When the user was last modified.",
      "format": "date-time",
      "example": "2019-02-19T13:15:27Z"
    },
    "lastName": {
      "type": "string",
      "description": "The last name of this user.  This value may or may not be required depending on configuration."
    },
    "locale": {
      "type": "string",
      "description": "The locale of this user.  If not set, the default account locale will be used."
    },
    "locked": {
      "type": "boolean",
      "description": "A flag indicating if this user is locked."
    },
    "lockedAuthenticatorTypes": {
      "type": "array",
      "description": "The user authenticators that are locked.",
      "items": {
        "type": "string",
        "description": "The user authenticators that are locked.",
        "enum": [
          "MACHINE",
          "PASSWORD",
          "EXTERNAL",
          "KBA",
          "TEMP_ACCESS_CODE",
          "OTP",
          "GRID",
          "TOKEN",
          "TOKENCR",
          "TOKENPUSH",
          "FIDO",
          "SMARTCREDENTIALPUSH",
          "PASSWORD_AND_SECONDFACTOR",
          "SMART_LOGIN",
          "IDP",
          "PASSKEY",
          "IDP_AND_SECONDFACTOR",
          "USER_CERTIFICATE",
          "FACE",
          "PASSTHROUGH",
          "MAGICLINK"
        ]
      }
    },
    "lockedAuthenticators": {
      "type": "array",
      "description": "The user authenticators that are locked. Deprecated: use lockedAuthenticatorTypes",
      "deprecated": true,
      "items": {
        "type": "string",
        "description": "The user authenticators that are locked. Deprecated: use lockedAuthenticatorTypes",
        "deprecated": true,
        "enum": [
          "PASSWORD",
          "KBA",
          "TEMP_ACCESS_CODE",
          "GRID",
          "OTP_EMAIL",
          "OTP_SMS",
          "OTP_VOICE",
          "ENTRUST_SOFT_TOKEN",
          "ENTRUST_SOFT_TOKEN_PUSH",
          "GOOGLE_AUTHENTICATOR",
          "HARDWARE_TOKEN",
          "FIDO",
          "SMARTCREDENTIALPUSH",
          "USER_CERTIFICATE",
          "MACHINE",
          "FACE",
          "PASSTHROUGH",
          "TOKENCR",
          "MAGICLINK"
        ]
      }
    },
    "lockoutExpiry": {
      "type": "string",
      "description": "If the user is locked, this value will specify the time at which the lockout will expire.",
      "format": "date-time",
      "example": "2019-02-19T13:15:27Z"
    },
    "magicLinkEnabled": {
      "type": "boolean",
      "description": "Indicates whether Magic Links are enabled for this user.",
      "example": true
    },
    "migrated": {
      "type": "boolean",
      "description": "A flag indicating if this user was migrated from Entrust IdentityGuard."
    },
    "mobile": {
      "type": "string",
      "description": "The mobile number of this user.  This value may or may not be required depending on configuration. It must be set to use SMS OTP authentication."
    },
    "oauthRoles": {
      "type": "array",
      "description": "A list of all oauth roles to which this user belongs.",
      "items": {
        "required": [
          "ancestorIds",
          "descendantIds",
          "id",
          "inheritedResourceServerScopeIds",
          "name",
          "resourceServerScopeIds"
        ],
        "type": "object",
        "properties": {
          "ancestorIds": {
            "type": "array",
            "description": "The set of ancestor oauth role ids.",
            "items": {
              "type": "string",
              "description": "The set of ancestor oauth role ids."
            }
          },
          "descendantIds": {
            "type": "array",
            "description": "The set of descendant oauth role ids.",
            "items": {
              "type": "string",
              "description": "The set of descendant oauth role ids."
            }
          },
          "description": {
            "type": "string",
            "description": "The description of this oauth role."
          },
          "id": {
            "type": "string",
            "description": "The UUID of this oauth role. This value is generated when the oauth role is created."
          },
          "inheritedResourceServerScopeIds": {
            "type": "array",
            "description": "The set of resource server scopes ids associated with this oauth role based on inheritance from its ancestors.",
            "items": {
              "type": "string",
              "description": "The set of resource server scopes ids associated with this oauth role based on inheritance from its ancestors."
            }
          },
          "name": {
            "type": "string",
            "description": "The name of this oauth role."
          },
          "parentId": {
            "type": "string",
            "description": "The UUID of the parent of this oauth role, if one exists."
          },
          "resourceServerScopeIds": {
            "type": "array",
            "description": "The set of resource server scopes ids associated with this oauth role.",
            "items": {
              "type": "string",
              "description": "The set of resource server scopes ids associated with this oauth role."
            }
          }
        },
        "description": "A list of all oauth roles to which this user belongs.",
        "title": "OAuthRole"
      }
    },
    "organizations": {
      "type": "array",
      "description": "A list of the user organizations.",
      "items": {
        "required": [
          "displayName",
          "id",
          "name"
        ],
        "type": "object",
        "properties": {
          "description": {
            "type": "string",
            "description": "The description of the organization."
          },
          "displayName": {
            "type": "string",
            "description": "The display name of the organization."
          },
          "id": {
            "type": "string",
            "description": "The unique UUID assigned to the organization when it is created."
          },
          "logoUri": {
            "type": "string",
            "description": "The URI of the logo to display when showing organizations.",
            "example": "https://account.mycompany.com/images/logo.png"
          },
          "name": {
            "type": "string",
            "description": "The name of the organization."
          }
        },
        "description": "Organization defines the attributes of an organization used in B2B scenarios.",
        "title": "Organization"
      }
    },
    "otpCreateTime": {
      "type": "string",
      "description": "If the user has an OTP, this attribute specifies when the user's OTP was created.",
      "format": "date-time",
      "example": "2019-02-11T11:45:27Z"
    },
    "passwordCompromised": {
      "type": "boolean",
      "description": "A flag indicating if the user password is compromised.",
      "deprecated": true
    },
    "passwordExpirationTime": {
      "type": "string",
      "description": "The password expiration time.",
      "format": "date-time",
      "deprecated": true,
      "example": "2019-02-19T13:15:27Z"
    },
    "phone": {
      "type": "string",
      "description": "The phone number of this user.  This value may or may not be required depending on configuration. It must be set to use VOICE OTP authentication."
    },
    "preferredOtpDelivery": {
      "type": "string",
      "description": "Preferred OTP delivery type (SMS, EMAIL or VOICE) or SYSTEM to use the system defined default.",
      "example": "SYSTEM",
      "enum": [
        "EMAIL",
        "SMS",
        "VOICE",
        "SYSTEM"
      ]
    },
    "preferredOtpDeliveryContactAttributes": {
      "type": "object",
      "additionalProperties": {
        "type": "string",
        "description": "Preferred OTP delivery contact attribute for the given type (i.e., OTP_EMAIL, OTP_SMS, OTP_VOICE. An empty string means no override for that type).",
        "example": "{\"OTP_EMAIL\":\"Email\",\"OTP_SMS\":\"Personal Mobile\",\"OTP_VOICE\":\"default\"}"
      },
      "description": "Preferred OTP delivery contact attribute for the given type (i.e., OTP_EMAIL, OTP_SMS, OTP_VOICE. An empty string means no override for that type).",
      "example": {
        "OTP_EMAIL": "Email",
        "OTP_SMS": "Personal Mobile",
        "OTP_VOICE": "default"
      }
    },
    "registrationEnabled": {
      "type": "boolean",
      "description": "Indicates whether registration is enabled for this user.",
      "example": true
    },
    "registrationRequired": {
      "type": "boolean",
      "description": "Indicates whether self-registration is required. This attribute doesn't apply to administrators.",
      "example": true
    },
    "securityId": {
      "type": "string",
      "description": "The security ID of this user. The security ID is a unique value used to identity the user when performing smart card login to Microsoft Windows.",
      "example": "8c35d5f2-a18a-11ed-a8fc-0242ac120002"
    },
    "showNotification": {
      "type": "boolean",
      "description": "Indicates whether to show notifications to this user.",
      "example": true
    },
    "smartCredentials": {
      "type": "array",
      "description": "A list of all the smart credentials owned by this user.",
      "items": {
        "required": [
          "deviceVerified"
        ],
        "type": "object",
        "properties": {
          "allowedActions": {
            "type": "array",
            "description": "A list of administration actions currently allowed for this smart credential.",
            "items": {
              "type": "string",
              "description": "A list of administration actions currently allowed for this smart credential.",
              "enum": [
                "ACTIVATE",
                "REACTIVATE",
                "UPDATE",
                "UNASSIGN",
                "UNBLOCK",
                "ENABLE",
                "DISABLE",
                "DELETE",
                "VIEW_CERTIFICATES"
              ]
            }
          },
          "cardDigitalConfig": {
            "type": "object",
            "properties": {
              "allCAGroups": {
                "type": "boolean",
                "description": "If true, digital ids using this config will be set to have all CA groups."
              },
              "caGroups": {
                "type": "array",
                "description": "If allCAGroups is set to false then digital ids using this config will use this specified list of CA groups.",
                "items": {
                  "type": "string",
                  "description": "If allCAGroups is set to false then digital ids using this config will use this specified list of CA groups."
                }
              },
              "caId": {
                "type": "string",
                "description": "The UUID of the CA for this digital id config."
              },
              "caName": {
                "type": "string",
                "description": "The name of the CA for this digital id config."
              },
              "caType": {
                "type": "string",
                "description": "The CA type of this Digital Id Config.",
                "enum": [
                  "EDC",
                  "MS",
                  "PKIAAS"
                ]
              },
              "certTemplates": {
                "type": "array",
                "description": "A list of cert templates associated with this digital id config.",
                "items": {
                  "type": "object",
                  "properties": {
                    "digitalIdConfigId": {
                      "type": "string",
                      "description": "The UUID of the Digital Id Config that owns this Digital Id Config Cert Template."
                    },
                    "id": {
                      "type": "string",
                      "description": "The UUID of the Digital Id Config Cert Template."
                    },
                    "keyType": {
                      "type": "string",
                      "description": "The key type of the Digital Id Config Cert Template.",
                      "enum": [
                        "RSA_2048",
                        "EC_P_256"
                      ]
                    },
                    "lifetime": {
                      "type": "integer",
                      "description": "The lifetime (in months) of the certificate created with this Digital Id Config Cert Template.",
                      "format": "int32"
                    },
                    "name": {
                      "type": "string",
                      "description": "The name of the Digital Id Config Cert Template."
                    },
                    "pivContainer": {
                      "type": "string",
                      "description": "The PIV container of the Digital Id Config Cert Template.",
                      "enum": [
                        "PivAuth",
                        "CardAuth",
                        "DigSig",
                        "KeyMgmt",
                        "None"
                      ]
                    },
                    "useCaDefaultCertLifetime": {
                      "type": "boolean",
                      "description": "A flag indicating whether to use the CA's default certificate lifetime."
                    }
                  },
                  "description": "Information that describes a Digital Id Config Cert Template.",
                  "title": "DigitalIdConfigCertTemplate"
                }
              },
              "certificateType": {
                "type": "string",
                "description": "The CA certificate type which digital ids using this config will use."
              },
              "digitalIdConfigTemplateId": {
                "type": "string",
                "description": "When creating a digital id config, default values can be provided from this specified digital id config template."
              },
              "directoryEntry": {
                "type": "boolean",
                "description": "A flag indicating if digital ids using this config will create directory entries in the CA."
              },
              "dnFormat": {
                "type": "string",
                "description": "The format which digital ids using this config will use for their DN."
              },
              "dnFormatSearchbaseIncluded": {
                "type": "boolean",
                "description": "Whether digital ids using this config should include the searchbase in their DN."
              },
              "id": {
                "type": "string",
                "description": "The UUID of this Digital Id Config."
              },
              "name": {
                "type": "string",
                "description": "The name of this Digital Id Config."
              },
              "role": {
                "type": "string",
                "description": "The CA role which digital ids using this config will use."
              },
              "searchbase": {
                "type": "string",
                "description": "The searchbase within the CA in which digital ids using this config will be created."
              },
              "subjectAltNames": {
                "type": "array",
                "description": "A list of subjectAltNames associated with this digital id config.",
                "items": {
                  "type": "object",
                  "properties": {
                    "digitalIdConfigId": {
                      "type": "string",
                      "description": "The UUID of the digital id config that owns this subjectAltName."
                    },
                    "id": {
                      "type": "string",
                      "description": "The UUID of this Digital Id Config SubjectAltName."
                    },
                    "type": {
                      "type": "string",
                      "description": "The type of subjectAltName.",
                      "enum": [
                        "EMAIL",
                        "UPN",
                        "IP",
                        "DNS",
                        "OTHER",
                        "X400",
                        "DN",
                        "EDI",
                        "URI",
                        "REGISTERED_ID"
                      ]
                    },
                    "value": {
                      "type": "string",
                      "description": "The value for the subjectAltName."
                    }
                  },
                  "description": "Information that describes a Digital Id Config SubjectAltName.",
                  "title": "DigitalIdConfigSubjectAltName"
                }
              },
              "type": {
                "type": "string",
                "description": "The type of digital id.",
                "enum": [
                  "PIV_CARDHOLDER",
                  "PIV_CARD"
                ]
              },
              "userType": {
                "type": "string",
                "description": "The CA user type which digital ids using this config will use."
              },
              "variables": {
                "type": "array",
                "description": "A list of variables associated with this digital id config.",
                "items": {
                  "type": "object",
                  "properties": {
                    "digitalIdConfigId": {
                      "type": "string",
                      "description": "The UUID of the Digital Id Config that owns this Digital Id Config Variable."
                    },
                    "id": {
                      "type": "string",
                      "description": "The UUID of the Digital Id Config Variable."
                    },
                    "includedInDN": {
                      "type": "boolean",
                      "description": "A flag indicating if values for this variable are included in the Digital Id's DN when it is generated by the CA."
                    },
                    "name": {
                      "type": "string",
                      "description": "The name of the Digital Id Config Variable."
                    },
                    "type": {
                      "type": "string",
                      "description": "The type of the Digital Id Config Variable.",
                      "enum": [
                        "CERTIFICATE",
                        "USER",
                        "VARIABLE",
                        "CUSTOM"
                      ]
                    },
                    "value": {
                      "type": "string",
                      "description": "The value of the Digital Id Config Variable."
                    }
                  },
                  "description": "Information that describes a Digital Id Config Variable.",
                  "title": "DigitalIdConfigVariable"
                }
              }
            },
            "description": "Information that defines how digital ids are created in the CA.",
            "title": "DigitalIdConfig"
          },
          "cardDigitalConfigId": {
            "type": "string",
            "description": "The UUID of the Card Digital Id config of this smart credential. If not set, the smart credential will not have a Card Digital Id."
          },
          "cardDigitalConfigRequired": {
            "type": "boolean",
            "description": "Indicates if the card digitalid config is required or not."
          },
          "cardHolderDigitalConfig": {
            "type": "object",
            "properties": {
              "allCAGroups": {
                "type": "boolean",
                "description": "If true, digital ids using this config will be set to have all CA groups."
              },
              "caGroups": {
                "type": "array",
                "description": "If allCAGroups is set to false then digital ids using this config will use this specified list of CA groups.",
                "items": {
                  "type": "string",
                  "description": "If allCAGroups is set to false then digital ids using this config will use this specified list of CA groups."
                }
              },
              "caId": {
                "type": "string",
                "description": "The UUID of the CA for this digital id config."
              },
              "caName": {
                "type": "string",
                "description": "The name of the CA for this digital id config."
              },
              "caType": {
                "type": "string",
                "description": "The CA type of this Digital Id Config.",
                "enum": [
                  "EDC",
                  "MS",
                  "PKIAAS"
                ]
              },
              "certTemplates": {
                "type": "array",
                "description": "A list of cert templates associated with this digital id config.",
                "items": {
                  "type": "object",
                  "properties": {
                    "digitalIdConfigId": {
                      "type": "string",
                      "description": "The UUID of the Digital Id Config that owns this Digital Id Config Cert Template."
                    },
                    "id": {
                      "type": "string",
                      "description": "The UUID of the Digital Id Config Cert Template."
                    },
                    "keyType": {
                      "type": "string",
                      "description": "The key type of the Digital Id Config Cert Template.",
                      "enum": [
                        "RSA_2048",
                        "EC_P_256"
                      ]
                    },
                    "lifetime": {
                      "type": "integer",
                      "description": "The lifetime (in months) of the certificate created with this Digital Id Config Cert Template.",
                      "format": "int32"
                    },
                    "name": {
                      "type": "string",
                      "description": "The name of the Digital Id Config Cert Template."
                    },
                    "pivContainer": {
                      "type": "string",
                      "description": "The PIV container of the Digital Id Config Cert Template.",
                      "enum": [
                        "PivAuth",
                        "CardAuth",
                        "DigSig",
                        "KeyMgmt",
                        "None"
                      ]
                    },
                    "useCaDefaultCertLifetime": {
                      "type": "boolean",
                      "description": "A flag indicating whether to use the CA's default certificate lifetime."
                    }
                  },
                  "description": "Information that describes a Digital Id Config Cert Template.",
                  "title": "DigitalIdConfigCertTemplate"
                }
              },
              "certificateType": {
                "type": "string",
                "description": "The CA certificate type which digital ids using this config will use."
              },
              "digitalIdConfigTemplateId": {
                "type": "string",
                "description": "When creating a digital id config, default values can be provided from this specified digital id config template."
              },
              "directoryEntry": {
                "type": "boolean",
                "description": "A flag indicating if digital ids using this config will create directory entries in the CA."
              },
              "dnFormat": {
                "type": "string",
                "description": "The format which digital ids using this config will use for their DN."
              },
              "dnFormatSearchbaseIncluded": {
                "type": "boolean",
                "description": "Whether digital ids using this config should include the searchbase in their DN."
              },
              "id": {
                "type": "string",
                "description": "The UUID of this Digital Id Config."
              },
              "name": {
                "type": "string",
                "description": "The name of this Digital Id Config."
              },
              "role": {
                "type": "string",
                "description": "The CA role which digital ids using this config will use."
              },
              "searchbase": {
                "type": "string",
                "description": "The searchbase within the CA in which digital ids using this config will be created."
              },
              "subjectAltNames": {
                "type": "array",
                "description": "A list of subjectAltNames associated with this digital id config.",
                "items": {
                  "type": "object",
                  "properties": {
                    "digitalIdConfigId": {
                      "type": "string",
                      "description": "The UUID of the digital id config that owns this subjectAltName."
                    },
                    "id": {
                      "type": "string",
                      "description": "The UUID of this Digital Id Config SubjectAltName."
                    },
                    "type": {
                      "type": "string",
                      "description": "The type of subjectAltName.",
                      "enum": [
                        "EMAIL",
                        "UPN",
                        "IP",
                        "DNS",
                        "OTHER",
                        "X400",
                        "DN",
                        "EDI",
                        "URI",
                        "REGISTERED_ID"
                      ]
                    },
                    "value": {
                      "type": "string",
                      "description": "The value for the subjectAltName."
                    }
                  },
                  "description": "Information that describes a Digital Id Config SubjectAltName.",
                  "title": "DigitalIdConfigSubjectAltName"
                }
              },
              "type": {
                "type": "string",
                "description": "The type of digital id.",
                "enum": [
                  "PIV_CARDHOLDER",
                  "PIV_CARD"
                ]
              },
              "userType": {
                "type": "string",
                "description": "The CA user type which digital ids using this config will use."
              },
              "variables": {
                "type": "array",
                "description": "A list of variables associated with this digital id config.",
                "items": {
                  "type": "object",
                  "properties": {
                    "digitalIdConfigId": {
                      "type": "string",
                      "description": "The UUID of the Digital Id Config that owns this Digital Id Config Variable."
                    },
                    "id": {
                      "type": "string",
                      "description": "The UUID of the Digital Id Config Variable."
                    },
                    "includedInDN": {
                      "type": "boolean",
                      "description": "A flag indicating if values for this variable are included in the Digital Id's DN when it is generated by the CA."
                    },
                    "name": {
                      "type": "string",
                      "description": "The name of the Digital Id Config Variable."
                    },
                    "type": {
                      "type": "string",
                      "description": "The type of the Digital Id Config Variable.",
                      "enum": [
                        "CERTIFICATE",
                        "USER",
                        "VARIABLE",
                        "CUSTOM"
                      ]
                    },
                    "value": {
                      "type": "string",
                      "description": "The value of the Digital Id Config Variable."
                    }
                  },
                  "description": "Information that describes a Digital Id Config Variable.",
                  "title": "DigitalIdConfigVariable"
                }
              }
            },
            "description": "Information that defines how digital ids are created in the CA.",
            "title": "DigitalIdConfig"
          },
          "cardHolderDigitalConfigId": {
            "type": "string",
            "description": "The UUID of the Card Holder Digital Id config of this smart credential. If not set, the smart credential will not have a Card Holder Digital Id."
          },
          "cardHolderDigitalConfigRequired": {
            "type": "boolean",
            "description": "Indicates if the card holder digitalid config is required or not."
          },
          "certificates": {
            "type": "array",
            "description": "A list of certificates associated with this smart credential.",
            "items": {
              "type": "object",
              "properties": {
                "description": {
                  "type": "string",
                  "description": "The description providing the purpose of this certificate."
                },
                "digitalIdId": {
                  "type": "string",
                  "description": "The UUID of the digital id to which this certificate belongs"
                },
                "digitalIdType": {
                  "type": "string",
                  "description": "The type of the digital Id to which this certificate belongs.",
                  "enum": [
                    "PIV_CARDHOLDER",
                    "PIV_CARD"
                  ]
                },
                "id": {
                  "type": "string",
                  "description": "The UUID of this Digital Id Certificate."
                },
                "issuerDN": {
                  "type": "string",
                  "description": "The issuer DN of this certificate."
                },
                "notAfter": {
                  "type": "string",
                  "description": "The expiry date of this certificate.",
                  "format": "date-time",
                  "example": "2019-02-19T13:15:27Z"
                },
                "notBefore": {
                  "type": "string",
                  "description": "The issue date of this certificate.",
                  "format": "date-time",
                  "example": "2019-02-19T13:15:27Z"
                },
                "pivContainer": {
                  "type": "string",
                  "description": "The name of the PIV container that stores this certificate on the smart card."
                },
                "serialNumber": {
                  "type": "string",
                  "description": "The serial number of this certificate."
                },
                "status": {
                  "type": "string",
                  "description": "The status of this certificate. If not set, the revocation status has not been retrieved from the CA.",
                  "enum": [
                    "ACTIVE",
                    "REVOKED",
                    "HOLD",
                    "EXPIRED",
                    "NOT_AVAILABLE"
                  ]
                },
                "subjectDN": {
                  "type": "string",
                  "description": "The subject DN of this certificate."
                }
              },
              "description": "Information stored about a certificate associated with a digital id.",
              "title": "DigitalIdCert"
            }
          },
          "chipId": {
            "type": "string",
            "description": "The chip id of the smart card set when the smart credential is encoded."
          },
          "deviceVerified": {
            "type": "boolean",
            "description": "A flag indicating if the smart credential is enrolled on a verified device."
          },
          "digitalIds": {
            "type": "array",
            "description": "A list of digital ids associated with this smart credential.",
            "items": {
              "type": "object",
              "properties": {
                "certificates": {
                  "type": "array",
                  "description": "The certificates associated with this digital id.",
                  "items": {
                    "type": "object",
                    "properties": {
                      "description": {
                        "type": "string",
                        "description": "The description providing the purpose of this certificate."
                      },
                      "digitalIdId": {
                        "type": "string",
                        "description": "The UUID of the digital id to which this certificate belongs"
                      },
                      "digitalIdType": {
                        "type": "string",
                        "description": "The type of the digital Id to which this certificate belongs.",
                        "enum": [
                          "PIV_CARDHOLDER",
                          "PIV_CARD"
                        ]
                      },
                      "id": {
                        "type": "string",
                        "description": "The UUID of this Digital Id Certificate."
                      },
                      "issuerDN": {
                        "type": "string",
                        "description": "The issuer DN of this certificate."
                      },
                      "notAfter": {
                        "type": "string",
                        "description": "The expiry date of this certificate.",
                        "format": "date-time",
                        "example": "2019-02-19T13:15:27Z"
                      },
                      "notBefore": {
                        "type": "string",
                        "description": "The issue date of this certificate.",
                        "format": "date-time",
                        "example": "2019-02-19T13:15:27Z"
                      },
                      "pivContainer": {
                        "type": "string",
                        "description": "The name of the PIV container that stores this certificate on the smart card."
                      },
                      "serialNumber": {
                        "type": "string",
                        "description": "The serial number of this certificate."
                      },
                      "status": {
                        "type": "string",
                        "description": "The status of this certificate. If not set, the revocation status has not been retrieved from the CA.",
                        "enum": [
                          "ACTIVE",
                          "REVOKED",
                          "HOLD",
                          "EXPIRED",
                          "NOT_AVAILABLE"
                        ]
                      },
                      "subjectDN": {
                        "type": "string",
                        "description": "The subject DN of this certificate."
                      }
                    },
                    "description": "Information stored about a certificate associated with a digital id.",
                    "title": "DigitalIdCert"
                  }
                },
                "digitalIdConfigId": {
                  "type": "string",
                  "description": "The UUID of the digital Id config that defines this digital Id."
                },
                "digitalIdConfigName": {
                  "type": "string",
                  "description": "The name of the digital id Config that defines this digital Id."
                },
                "digitalIdConfigType": {
                  "type": "string",
                  "description": "The type of this digital Id.",
                  "enum": [
                    "PIV_CARDHOLDER",
                    "PIV_CARD"
                  ]
                },
                "dn": {
                  "type": "string",
                  "description": "The current DN of the digital id."
                },
                "id": {
                  "type": "string",
                  "description": "The UUID of this DigitalId."
                }
              },
              "description": "Information stored about a digital id.",
              "title": "DigitalId"
            }
          },
          "encodeMsg": {
            "type": "string",
            "description": "For smart credentials that have failed to encode, the encode message stores a message providing information about the failure."
          },
          "encodeState": {
            "type": "string",
            "description": "The encode state of a smart credential indicates if encoding has started, completed successfully or failed.",
            "enum": [
              "ENCODE_START",
              "ENCODE_DONE",
              "ENCODE_ERROR"
            ]
          },
          "enrollState": {
            "type": "string",
            "description": "The enrollment state of a smart credential indicates if all of the necessary enrollment values have been collected. Only smart credentials in the ENROLLED state can be activated.",
            "enum": [
              "ENROLLING",
              "ENROLLED"
            ]
          },
          "expiryDate": {
            "type": "string",
            "description": "For issued smart credentials, the expiry date is the date on which the smart credential will expire.",
            "format": "date-time",
            "example": "2019-02-19T13:15:27Z"
          },
          "id": {
            "type": "string",
            "description": "The unique UUID assigned to the smart credential when it is created."
          },
          "issueDate": {
            "type": "string",
            "description": "The date on which the smart credential was issued.",
            "format": "date-time",
            "example": "2019-02-19T13:15:27Z"
          },
          "notifyEnabled": {
            "type": "boolean",
            "description": "A flag indicating if notification is enabled for this smart credential."
          },
          "platform": {
            "type": "string",
            "description": "The platform of the Mobile SC application on which this smart credential was encoded."
          },
          "scDefnId": {
            "type": "string",
            "description": "The UUID of the Smart Credential Definition that defines this smart credential."
          },
          "scDefnName": {
            "type": "string",
            "description": "The name of the smart credential definition of this smart credential."
          },
          "serialNumber": {
            "type": "string",
            "description": "The unique serial number of the smart credential generated when it is created."
          },
          "state": {
            "type": "string",
            "description": "The state of the smart credential.  Only smart credentials in the ACTIVE state can be used for authentication.",
            "enum": [
              "ACTIVE",
              "INACTIVE"
            ]
          },
          "userId": {
            "type": "string",
            "description": "The UUID of the user that owns this smart credential."
          },
          "userUserId": {
            "type": "string",
            "description": "The user Id of the user that owns this smart credential."
          },
          "variableValues": {
            "type": "array",
            "description": "Variable values for this smart credential",
            "items": {
              "type": "object",
              "properties": {
                "scDefnVariable": {
                  "type": "object",
                  "properties": {
                    "defaultValue": {
                      "type": "string",
                      "description": "The default value of this variable."
                    },
                    "displayable": {
                      "type": "boolean",
                      "description": "A flag indicating if values for this variable should be displayed."
                    },
                    "generate": {
                      "type": "boolean",
                      "description": "A flag indicating if the initial value for this variable should be generated."
                    },
                    "generateLength": {
                      "type": "integer",
                      "description": "A length value used when generating values for this variable.",
                      "format": "int32"
                    },
                    "id": {
                      "type": "string",
                      "description": "The UUID of this SC Defn Variable."
                    },
                    "modifiable": {
                      "type": "boolean",
                      "description": "A flag indicating if values for this variable can be modified."
                    },
                    "name": {
                      "type": "string",
                      "description": "The name of this SC Defn Variable."
                    },
                    "order": {
                      "type": "integer",
                      "description": "A value that specifies the order of this variable with respect to the other variables in the SC Defn.",
                      "format": "int32"
                    },
                    "prompt": {
                      "type": "string",
                      "description": "Optional prompt to be used when prompting for a value for this variable."
                    },
                    "required": {
                      "type": "boolean",
                      "description": "A flag indicating if a value is required for this variable."
                    },
                    "restrictionDigits": {
                      "type": "string",
                      "description": "A value specifying restrictions on digits appearing in values of this variable.",
                      "enum": [
                        "ALLOWED",
                        "REQUIRED",
                        "NOT_ALLOWED",
                        "NOT_SET"
                      ]
                    },
                    "restrictionLower": {
                      "type": "string",
                      "description": "A value specifying restrictions on lowercase characters appearing in values of this variable.",
                      "enum": [
                        "ALLOWED",
                        "REQUIRED",
                        "NOT_ALLOWED",
                        "NOT_SET"
                      ]
                    },
                    "restrictionMax": {
                      "type": "integer",
                      "description": "A value indicating a maximum for values of this variable. How this is enforced depends on the variable type.",
                      "format": "int32"
                    },
                    "restrictionMin": {
                      "type": "integer",
                      "description": "A value indicating a minimum for values of this variable. How this is enforced depends on the variable type.",
                      "format": "int32"
                    },
                    "restrictionRegex": {
                      "type": "string",
                      "description": "A value specifying a regex that values of this variable must match."
                    },
                    "restrictionSpecial": {
                      "type": "string",
                      "description": "A value specifying restrictions on special characters appearing in values of this variable.",
                      "enum": [
                        "ALLOWED",
                        "REQUIRED",
                        "NOT_ALLOWED",
                        "NOT_SET"
                      ]
                    },
                    "restrictionUpper": {
                      "type": "string",
                      "description": "A value specifying restrictions on uppercase characters appearing in values of this variable.",
                      "enum": [
                        "ALLOWED",
                        "REQUIRED",
                        "NOT_ALLOWED",
                        "NOT_SET"
                      ]
                    },
                    "scDefnId": {
                      "type": "string",
                      "description": "The UUID of the SC Defn that owns this variable definition."
                    },
                    "type": {
                      "type": "string",
                      "description": "The type of this variable.",
                      "enum": [
                        "STRING",
                        "BOOLEAN",
                        "INTEGER",
                        "UUID"
                      ]
                    },
                    "uniqueness": {
                      "type": "string",
                      "description": "A flag indicating if values of this variable must be unique and if so within what scope.",
                      "enum": [
                        "GLOBAL",
                        "USER",
                        "NONE"
                      ]
                    },
                    "uniquenessScopeId": {
                      "type": "string",
                      "description": "A value that allows a variable to be defined unique in the scope of another variable."
                    }
                  },
                  "description": "SC Defn Variables define the details about variables defined in the SC Defn.",
                  "title": "SCDefnVariable"
                },
                "scDefnVariableId": {
                  "type": "string",
                  "description": "The UUID of the SC Defn Variable that defines the variable."
                },
                "value": {
                  "type": "string",
                  "description": "The variable value."
                }
              },
              "description": "SCVariableValues store variable values for a smart credential.",
              "title": "SCVariableValue"
            }
          },
          "version": {
            "type": "string",
            "description": "The version of the Mobile SC application on which this smart credential was encoded."
          }
        },
        "description": "Information returned from the service about a smart credential.",
        "title": "SmartCredential"
      }
    },
    "state": {
      "type": "string",
      "description": "The state of this user.  Only users in the ACTIVE state can perform authentication.",
      "enum": [
        "ACTIVE",
        "INACTIVE"
      ]
    },
    "tempAccessCode": {
      "type": "object",
      "properties": {
        "code": {
          "type": "string",
          "description": "The actual temporary access code.  This value will only be returned if the administrator has the TEMPACCESSCODECONTENTS:VIEW permission."
        },
        "createDate": {
          "type": "string",
          "description": "The date on which this temporary access code was created.",
          "format": "date-time",
          "example": "2019-02-19T13:15:27Z"
        },
        "expired": {
          "type": "boolean",
          "description": "A flag indicating if this temporary access code is expired now."
        },
        "expiryDate": {
          "type": "string",
          "description": "The expiry date of this temporary access code.  If not set, it never expires.",
          "format": "date-time",
          "example": "2019-03-19T13:15:27Z"
        },
        "id": {
          "type": "string",
          "description": "The unique UUID assigned to the temporary access code when it is created."
        },
        "maxUses": {
          "type": "integer",
          "description": "The maximum number of times this temporary access code can be used.  If not set, there are no limits.",
          "format": "int32"
        },
        "numUses": {
          "type": "integer",
          "description": "The number of times this temporary access code has been used.",
          "format": "int32"
        }
      },
      "description": "Information returned from the service about a temporary access code.",
      "title": "TempAccessCode"
    },
    "tokens": {
      "type": "array",
      "description": "A list of all the tokens owned by this user.",
      "items": {
        "required": [
          "appVerified",
          "deviceVerified",
          "pushDeliveryEnabled"
        ],
        "type": "object",
        "properties": {
          "algorithmType": {
            "type": "string",
            "description": "The algorithm type used by the token that was created or loaded into the system to generate OTP values.",
            "enum": [
              "AT",
              "OATH_HOTP",
              "OATH_OCRA",
              "OATH_TOTP",
              "VENDOR"
            ]
          },
          "allowedActions": {
            "type": "array",
            "description": "Actions that can be performed on this token.",
            "items": {
              "type": "string",
              "description": "Actions that can be performed on this token.",
              "enum": [
                "ACTIVATE",
                "REACTIVATE",
                "ACTIVATE_COMPLETE",
                "DELETE",
                "UNLOCK",
                "ENABLE",
                "DISABLE",
                "RESET",
                "ASSIGN",
                "UNASSIGN"
              ]
            }
          },
          "appVerified": {
            "type": "boolean",
            "description": "A flag indicating if the token was activated on a verified app."
          },
          "description": {
            "type": "string",
            "description": "Optional text describing this token."
          },
          "deviceVerified": {
            "type": "boolean",
            "description": "A flag indicating if the token is activated on a verified device."
          },
          "groups": {
            "type": "array",
            "description": "The UUIDs of groups to which this token belongs.  This value is only used for unassigned tokens. Only groups to which the current administrator has access will be returned.",
            "items": {
              "type": "string",
              "description": "The UUIDs of groups to which this token belongs.  This value is only used for unassigned tokens. Only groups to which the current administrator has access will be returned."
            }
          },
          "id": {
            "type": "string",
            "description": "The unique UUID assigned to the token when it is created."
          },
          "identityVerificationStatus": {
            "type": "string",
            "description": "The identity verification status of the token.",
            "enum": [
              "NOT_REQUIRED",
              "REQUIRED",
              "PENDING",
              "VERIFIED",
              "FAILED"
            ]
          },
          "label": {
            "type": "string",
            "description": "Optional label to identify an assigned token: a String up to 100 characters.",
            "example": "PENDING"
          },
          "lastUsedDate": {
            "type": "string",
            "description": "The date on which the token was last used for authentication.  This value will be null if the token has never been used.",
            "format": "date-time",
            "example": "2019-02-20T10:05:27Z"
          },
          "loadDate": {
            "type": "string",
            "description": "The date on which the token was created or loaded into the system.",
            "format": "date-time",
            "example": "2019-02-19T13:15:27Z"
          },
          "logo": {
            "type": "string",
            "description": "Base-64 encoded logo. If a custom logo is provided by the customer it is returned. Otherwise a system default logo is returned."
          },
          "name": {
            "type": "string",
            "description": "An optional name for the token."
          },
          "platform": {
            "type": "string",
            "description": "The mobile device platform on which an Entrust Soft Token was activated."
          },
          "pushDeliveryEnabled": {
            "type": "boolean",
            "description": "A flag indicating if push delivery is enabled for this token.",
            "example": true
          },
          "registeredForTransactions": {
            "type": "boolean",
            "description": "A flag indicating if the Entrust Soft Token has registered for transactions. Only tokens that are registered can perform token push authentication."
          },
          "serialNumber": {
            "type": "string",
            "description": "The serial number of the token either generated when the token was created or loaded into the system."
          },
          "state": {
            "type": "string",
            "description": "The state of the token.  For most tokens, only tokens in the ACTIVE state can be used for authentication. Google Authenticator tokens in the ACTIVATING state can also be used for authentication.",
            "enum": [
              "NEW",
              "ACTIVATING",
              "ACTIVE",
              "INACTIVE",
              "UNASSIGNED"
            ]
          },
          "supportsChallengeResponse": {
            "type": "boolean",
            "description": "A flag indicating if the Token supports challenge response processing.",
            "example": false
          },
          "supportsResponse": {
            "type": "boolean",
            "description": "A flag indicating if the Token supports response processing.",
            "example": true
          },
          "supportsSignature": {
            "type": "boolean",
            "description": "A flag indicating if the Token supports signature processing.",
            "example": false
          },
          "supportsUnlock": {
            "type": "boolean",
            "description": "A flag indicating if the Token supports unlock processing.",
            "example": true
          },
          "supportsUnlockTOTP": {
            "type": "boolean",
            "description": "A flag indicating if the Token supports unlock using TOTP processing.",
            "example": false
          },
          "type": {
            "type": "string",
            "description": "The type of token specified when the token was created or loaded into the system.",
            "enum": [
              "ENTRUST_PHYSICAL_TOKEN",
              "ENTRUST_SOFT_TOKEN",
              "GOOGLE_AUTHENTICATOR",
              "OATH_PHYSICAL_TOKEN",
              "ENTRUST_LEGACY_TOKEN"
            ]
          },
          "userId": {
            "type": "string",
            "description": "If the token is assigned to a user, this value specifies that user's user id."
          }
        },
        "description": "Information returned from the service about a token.",
        "title": "Token"
      }
    },
    "type": {
      "type": "string",
      "description": "The type of user.  A value of LDAP_AD means the user was synchronized from a directory. A value of MGMT_UI means the user was created in Identity as a Service. A value of EXTERNAL means the user was synchronized from an external source.",
      "enum": [
        "LDAP_AD",
        "MGMT_UI",
        "EXTERNAL"
      ]
    },
    "userAliases": {
      "type": "array",
      "description": "A list of user aliases for this user.",
      "items": {
        "type": "object",
        "properties": {
          "id": {
            "type": "string",
            "description": "The UUID of this user alias set when the user alias is created.",
            "example": "76234da-3cf2-4t6u-8d02-8234fdfc472"
          },
          "type": {
            "type": "string",
            "description": "The type of user alias. A value of USERID is used for an alias that will represent the actual user id value. A value of CUSTOM is used for aliases manually created by an administrator.  A value of DERIVED is defined for future use and should not be used at this time.",
            "enum": [
              "CUSTOM",
              "DERIVED",
              "USERID"
            ]
          },
          "userId": {
            "type": "string",
            "description": "The UUID of the user to which this user alias belongs.",
            "example": "42133ed4-3cf2-4t6u-8d02-8234fdfc472"
          },
          "value": {
            "type": "string",
            "description": "The value for the user alias.",
            "example": "some-alias"
          }
        },
        "description": "Specifies an alias for a particular user.",
        "title": "UserAlias"
      }
    },
    "userAttributeValues": {
      "type": "array",
      "description": "A list of user attribute values for this user.",
      "items": {
        "type": "object",
        "properties": {
          "editable": {
            "type": "boolean",
            "description": "A flag indicating if this user attribute value can be modified."
          },
          "id": {
            "type": "string",
            "description": "The UUID of this user attribute value set when the user attribute value is created.",
            "example": "76234da-3cf2-4t6u-8d02-8234fdfc472"
          },
          "lastUpdate": {
            "type": "string",
            "description": "The last time the attribute value was updated.",
            "format": "date-time",
            "example": "2019-02-19T13:15:27Z"
          },
          "userAttribute": {
            "required": [
              "mandatory",
              "name",
              "systemDefined",
              "unique"
            ],
            "type": "object",
            "properties": {
              "id": {
                "type": "string",
                "description": "The UUID for this user attribute.  Generated when the user attribute is created."
              },
              "mandatory": {
                "type": "boolean",
                "description": "A flag indicating if users must have a value for this user attribute."
              },
              "name": {
                "type": "string",
                "description": "The name of this user attribute."
              },
              "systemDefined": {
                "type": "boolean",
                "description": "A flag indicating if this user attribute is one of the system defined user attributes."
              },
              "type": {
                "type": "string",
                "description": "Type of user attribute. Currently only used to specify the type of contact if the attribute is to be used for OTP delivery.",
                "example": "OTP_EMAIL",
                "enum": [
                  "NONE",
                  "OTP_EMAIL",
                  "OTP_SMS",
                  "OTP_VOICE",
                  "OTP_WECHAT",
                  "OTP_WHATSAPP"
                ]
              },
              "unique": {
                "type": "boolean",
                "description": "A flag indicating if this attribute is intended to be unique."
              }
            },
            "description": "Information about user attribute definitions.",
            "title": "UserAttribute"
          },
          "userAttributeId": {
            "type": "string",
            "description": "The UUID of the user attribute that defines this user attribute value.  The userAttributeId must be provided when creating or modifying a user attribute value.",
            "example": "76234da-3cf2-4t6u-8d02-8234fdfc472"
          },
          "userId": {
            "type": "string",
            "description": "The UUID of the user to which this user attribute value belongs.",
            "example": "John"
          },
          "value": {
            "type": "string",
            "description": "The value for the user attribute.",
            "example": "value"
          }
        },
        "description": "Specifies the value of a user attribute for a particular user.",
        "title": "UserAttributeValue"
      }
    },
    "userAuthenticatorPreference": {
      "type": "array",
      "description": "The user authenticator preference list.",
      "items": {
        "type": "string",
        "description": "The user authenticator preference list.",
        "enum": [
          "MACHINE",
          "PASSWORD",
          "EXTERNAL",
          "KBA",
          "TEMP_ACCESS_CODE",
          "OTP",
          "GRID",
          "TOKEN",
          "TOKENCR",
          "TOKENPUSH",
          "FIDO",
          "SMARTCREDENTIALPUSH",
          "PASSWORD_AND_SECONDFACTOR",
          "SMART_LOGIN",
          "IDP",
          "PASSKEY",
          "IDP_AND_SECONDFACTOR",
          "USER_CERTIFICATE",
          "FACE",
          "PASSTHROUGH",
          "MAGICLINK"
        ]
      }
    },
    "userCreationTime": {
      "type": "string",
      "description": "The time this user was created. ",
      "format": "date-time",
      "example": "2019-02-19T13:15:27Z"
    },
    "userExtraAttributes": {
      "type": "array",
      "description": "A list of extra optional attributes for this user.",
      "items": {
        "type": "object",
        "properties": {
          "id": {
            "type": "string",
            "description": "The UUID of this extra user attribute.",
            "readOnly": true,
            "example": "76234da-3cf2-4t6u-8d02-8234fdfc472"
          },
          "name": {
            "type": "string",
            "description": "The name for the extra user attribute.",
            "example": "some-attr-name"
          },
          "type": {
            "type": "string",
            "description": "Type of custom user attribute.",
            "example": "OTP_SMS",
            "enum": [
              "NONE",
              "OTP_EMAIL",
              "OTP_SMS",
              "OTP_VOICE",
              "OTP_WECHAT",
              "OTP_WHATSAPP"
            ]
          },
          "value": {
            "type": "string",
            "description": "The value for the extra user attribute.",
            "example": "some-value"
          }
        },
        "description": "Specifies an extra optional attribute for a particular user.",
        "title": "UserExtraAttribute"
      }
    },
    "userId": {
      "type": "string",
      "description": "The user ID for this user."
    },
    "userPasswordDetails": {
      "type": "array",
      "description": "A list of the user password details.",
      "items": {
        "type": "object",
        "properties": {
          "name": {
            "type": "string",
            "description": "The name of the password.",
            "example": "default"
          },
          "namedPasswordId": {
            "type": "string",
            "description": "The ID of the named password."
          },
          "passwordCompromised": {
            "type": "boolean",
            "description": "A flag indicating if the user password is compromised."
          },
          "passwordExpirationTime": {
            "type": "string",
            "description": "The password expiration time.",
            "format": "date-time",
            "deprecated": true,
            "example": "2019-02-19T13:15:27Z"
          }
        },
        "description": "Information returned when a user password details is queried.",
        "title": "UserPasswordDetails"
      }
    },
    "userPrincipalName": {
      "type": "string",
      "description": "The user principal name of this user.  This value may or may not be required depending on configuration."
    },
    "verificationEnabled": {
      "type": "boolean",
      "description": "Indicates whether verification is enabled for this user.",
      "example": true
    },
    "verificationRequired": {
      "type": "boolean",
      "description": "Indicates whether verification is required. This attribute doesn't apply to administrators.",
      "example": true
    }
  },
  "description": "The values stored for a user.  This structure is passed when creating or modifying a user.  It is returned when querying a user.",
  "title": "User"
}
```

### 400

Bad Request

#### application/json

Schema

```json
{
  "type": "object",
  "properties": {
    "errorCode": {
      "type": "string",
      "description": "Error Codes specific to cause of failure.",
      "example": "invalid_user_response"
    },
    "errorMessage": {
      "type": "string",
      "description": "Additional Error Message describing the error.",
      "example": "Application id cannot be null"
    },
    "parameters": {
      "type": "array",
      "description": "Optional additional error information.",
      "items": {
        "type": "object",
        "description": "Optional additional error information."
      }
    }
  },
  "description": "Object containing information about errors reported by services.",
  "title": "ErrorInfo"
}
```

### 401

Access denied

#### application/json

Schema

```json
{
  "type": "object",
  "properties": {
    "errorCode": {
      "type": "string",
      "description": "Error Codes specific to cause of failure.",
      "example": "invalid_user_response"
    },
    "errorMessage": {
      "type": "string",
      "description": "Additional Error Message describing the error.",
      "example": "Application id cannot be null"
    },
    "parameters": {
      "type": "array",
      "description": "Optional additional error information.",
      "items": {
        "type": "object",
        "description": "Optional additional error information."
      }
    }
  },
  "description": "Object containing information about errors reported by services.",
  "title": "ErrorInfo"
}
```

### 403

Forbidden

#### application/json

Schema

```json
{
  "type": "object",
  "properties": {
    "errorCode": {
      "type": "string",
      "description": "Error Codes specific to cause of failure.",
      "example": "invalid_user_response"
    },
    "errorMessage": {
      "type": "string",
      "description": "Additional Error Message describing the error.",
      "example": "Application id cannot be null"
    },
    "parameters": {
      "type": "array",
      "description": "Optional additional error information.",
      "items": {
        "type": "object",
        "description": "Optional additional error information."
      }
    }
  },
  "description": "Object containing information about errors reported by services.",
  "title": "ErrorInfo"
}
```

### 404

Not Found

#### application/json

Schema

```json
{
  "type": "object",
  "properties": {
    "errorCode": {
      "type": "string",
      "description": "Error Codes specific to cause of failure.",
      "example": "invalid_user_response"
    },
    "errorMessage": {
      "type": "string",
      "description": "Additional Error Message describing the error.",
      "example": "Application id cannot be null"
    },
    "parameters": {
      "type": "array",
      "description": "Optional additional error information.",
      "items": {
        "type": "object",
        "description": "Optional additional error information."
      }
    }
  },
  "description": "Object containing information about errors reported by services.",
  "title": "ErrorInfo"
}
```

### 409

Conflict

#### application/json

Schema

```json
{
  "type": "object",
  "properties": {
    "errorCode": {
      "type": "string",
      "description": "Error Codes specific to cause of failure.",
      "example": "invalid_user_response"
    },
    "errorMessage": {
      "type": "string",
      "description": "Additional Error Message describing the error.",
      "example": "Application id cannot be null"
    },
    "parameters": {
      "type": "array",
      "description": "Optional additional error information.",
      "items": {
        "type": "object",
        "description": "Optional additional error information."
      }
    }
  },
  "description": "Object containing information about errors reported by services.",
  "title": "ErrorInfo"
}
```

## Security

Requirements

```json
[
  {
    "AdminAPIAuthentication": [
      "USERS:VIEW"
    ]
  }
]
```
